unit U_DyeGreyClothOutEdit;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxCalendar, cxDropDownEdit, ComCtrls, ToolWin,
  cxGridLevel, cxGridCustomTableView, cxGridTableView, cxGridDBTableView,
  cxClasses, cxControls, cxGridCustomView, cxGrid, cxGridCustomPopupMenu,
  cxGridPopupMenu, ADODB, DBClient, cxButtonEdit, cxTextEdit, cxSpinEdit,
  StdCtrls, ExtCtrls, cxLookAndFeels, cxLookAndFeelPainters, dxSkinsCore,
  dxSkinsDefaultPainters, cxNavigator, dxDateRanges, dxBarBuiltInMenu,
  U_BaseInput, System.ImageList, Vcl.ImgList, dxScrollbarAnnotations, cxCheckBox;

type
  TfrmDyeGreyClothOutEdit = class(TfrmBaseInput)
    ToolBar1: TToolBar;
    TBAdd: TToolButton;
    TBDel: TToolButton;
    TBSave: TToolButton;
    TBClose: TToolButton;
    DataSource3: TDataSource;
    CDS_Sub: TClientDataSet;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    cxGridPopupMenu2: TcxGridPopupMenu;
    ToolButton1: TToolButton;
    cxGrid2: TcxGrid;
    Tv1: TcxGridDBTableView;
    Tv1Column2: TcxGridDBColumn;
    v1Column6: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    v1Column4: TcxGridDBColumn;
    Tv1OrderNo: TcxGridDBColumn;
    Tv1Column4: TcxGridDBColumn;
    Tv1F_Code: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    v1Column15: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    v1Column13: TcxGridDBColumn;
    Tv1F_Width: TcxGridDBColumn;
    Tv1Material: TcxGridDBColumn;
    Tv1finishDescription: TcxGridDBColumn;
    Tv1DlyDate: TcxGridDBColumn;
    v1Column14: TcxGridDBColumn;
    v1Column12: TcxGridDBColumn;
    cxGrid2Level1: TcxGridLevel;
    Tv1F_description: TcxGridDBColumn;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure TBAddClick(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBSaveClick(Sender: TObject);
    procedure Tv1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure ToolButton1Click(Sender: TObject);
    procedure Tv1Column2PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure v1Column13PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
  private
    { Private declarations }
    function SaveCKData(): Boolean;
  public
    { Public declarations }
    FBCId, FStkName, FKHName, FWorkshop: string;
  end;

var
  frmDyeGreyClothOutEdit: TfrmDyeGreyClothOutEdit;

implementation

uses
  U_DataLink, U_RTFun, U_ZDYHelp, U_DyeGreyClothStkSel, U_CompanySel,
  U_DyePlanForCardSel;

{$R *.dfm}

procedure TfrmDyeGreyClothOutEdit.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  inherited;
  Action := caFree;
end;

procedure TfrmDyeGreyClothOutEdit.TBAddClick(Sender: TObject);
begin
  try
    frmDyeGreyClothStkSel := TfrmDyeGreyClothStkSel.Create(Application);
    with frmDyeGreyClothStkSel do
    begin
      FstkName := Self.FstkName;
      if ShowModal = 1 then
      begin
        frmDyeGreyClothStkSel.CDS_Main.DisableControls;
        with frmDyeGreyClothStkSel.CDS_Main do
        begin
          First;
          while frmDyeGreyClothStkSel.CDS_Main.Locate('SSel', True, []) do
          begin
            with Self.CDS_Sub do
            begin
              Append;
              FieldByName('IOTime').Value := Trim(FormatDateTime('yyyy-MM-dd hh:mm:ss', Now));
              FieldByName('STKID').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('BCIOID').Value;
              FieldByName('IOType').Value := '加工出库';
              FieldByName('FromCoNo').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('FromCoNo').Value;
              FieldByName('FromCoName').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('FromCoName').Value;
              FieldByName('StkCoNo').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('StkCoNo').Value;
              FieldByName('StkCoName').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('StkCoName').Value;
              FieldByName('ToCoNo').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('StkCoNo').Value;
              FieldByName('ToCoName').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('StkCoName').Value;
              FieldByName('F_Name').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('F_Name').Value;
              FieldByName('C_Name').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('C_Name').Value;

              FieldByName('C_code').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('C_code').Value;
              FieldByName('OrderNo').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('OrderNo').Value;
              FieldByName('QtyUnit').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('QtyUnit').Value;
              FieldByName('Qty').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('STKQTY').Value;
              FieldByName('Piece').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('StkPiece').Value;
              FieldByName('BatchNo').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('BatchNo').Value;
              FieldByName('C_Width').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('C_Width').Value;
              FieldByName('C_GramWeight').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('C_GramWeight').Value;
              FieldByName('FromOrdNo').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('FromOrdNo').Value;
              FieldByName('F_Width').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('F_Width').Value;
              FieldByName('finishDescription').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('finishDescription').Value;
              FieldByName('Material').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('Material').Value;
              FieldByName('C_Color').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('C_Color').Value;

              FieldByName('DlyDate').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('DlyDate').Value;

              FieldByName('Note').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('Note').Value;
              FieldByName('F_description').Value := frmDyeGreyClothStkSel.CDS_Main.fieldbyname('F_description').Value;

            end;
            frmDyeGreyClothStkSel.CDS_Main.Delete;
          end;
        end;
        frmDyeGreyClothStkSel.CDS_Main.EnableControls;
      end;
    end;
  finally
    frmDyeGreyClothStkSel.Free;
  end;

end;

function TfrmDyeGreyClothOutEdit.SaveCKData(): Boolean;
var
  MBCIOID, Maxno: string;
begin
  try
    ADOQueryCmd.Connection.BeginTrans;
    CDS_Sub.DisableControls;
    with CDS_Sub do
    begin
      First;
      while not eof do
      begin
        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from BS_Cloth_IO where BCIOID=''' + Trim(CDS_Sub.fieldbyname('BCIOID').AsString) + '''');
          Open;
        end;
        MBCIOID := Trim(ADOQueryTemp.fieldbyname('BCIOID').AsString);
        if Trim(MBCIOID) = '' then
        begin
          if not GetLSNo(ADOQueryCmd, Maxno, 'PC', 'BS_Cloth_IO', 3, 1) then
            raise Exception.Create('取染色坯布出库编号失败！');
        end
        else
        begin
          Maxno := Trim(MBCIOID);
        end;

        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from BS_Cloth_IO where BCIOID=''' + Trim(Maxno) + '''');
          Open;
        end;
        with ADOQueryCmd do
        begin
          if Trim(MBCIOID) = '' then
          begin
            Append;
            FieldByName('Filler').Value := Trim(DName)
          end
          else
          begin
            Edit;
            FieldByName('Editer').Value := Trim(DName);
            FieldByName('EditTime').Value := SGetServerDate(ADOQueryTemp);
          end;
          RTSetSaveDataCDS(ADOQueryCmd, Tv1, CDS_Sub, 'BS_Cloth_IO', 2);
          FieldByName('STKName').Value := FSTKName;
          FieldByName('Workshop').Value := FWorkshop;
          FieldByName('BCIOID').Value := Trim(Maxno);
          FieldByName('IOFlag').Value := '出库';
          FieldByName('IOQtyFlag').Value := -1;
          FieldByName('STKID').Value := CDS_Sub.fieldbyname('STKID').Value;
          FieldByName('FromCoNo').Value := CDS_Sub.fieldbyname('FromCoNo').Value;
          FieldByName('FromCoName').Value := CDS_Sub.fieldbyname('FromCoName').Value;
          FieldByName('StkCoNo').Value := CDS_Sub.fieldbyname('StkCoNo').Value;
          FieldByName('ToCoNo').Value := CDS_Sub.fieldbyname('ToCoNo').Value;
          Post;
        end;
        with ADOQueryCmd do
        begin
          Close;
          sql.Clear;
          sql.Add('Update BS_Cloth_IO Set StkPiece=(select Sum(isnull(Piece,0)*IOQtyFlag) from BS_Cloth_IO A where A.STKID=BS_Cloth_IO.BCIOID)');
          sql.Add(',STKQty=(select Sum(isnull(Qty,0)*IOQtyFlag) from BS_Cloth_IO A where A.STKID=BS_Cloth_IO.BCIOID )');
          sql.Add('where BCIOID=''' + Trim(CDS_Sub.fieldbyname('STKID').AsString) + '''');
          ExecSQL;
        end;
        with ADOQueryTemp do
        begin
          Close;
          sql.Clear;
          sql.Add('select * from BS_Cloth_IO where BCIOID=''' + Trim(CDS_Sub.fieldbyname('STKID').AsString) + '''');
          Open;
        end;
        if ADOQueryTemp.FieldByName('StkPiece').Value < 0 then
          raise Exception.Create('出库数量大于入库数量不能保存！');

        if ADOQueryTemp.FieldByName('StkPiece').Value < 0 then
          raise Exception.Create('出库匹数大于入库匹数不能保存！');

        Edit;
        FieldByName('BCIOID').Value := Trim(Maxno);
        Post;
        Next;
      end;
    end;
    CDS_Sub.EnableControls;
    ADOQueryCmd.Connection.CommitTrans;
    Result := True;
  except
    Result := False;
    ADOQueryCmd.Connection.RollbackTrans;
    application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
  end;

end;

procedure TfrmDyeGreyClothOutEdit.TBCloseClick(Sender: TObject);
begin

  Close;
end;

procedure TfrmDyeGreyClothOutEdit.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if Key = VK_ESCAPE then  // VK_ESCAPE 是 ESC 键的常量
  begin
    Key := 0;  // 清除按键，防止继续传递
    Close;     // 或者 ModalResult := mrCancel;
  end;
end;

procedure TfrmDyeGreyClothOutEdit.FormShow(Sender: TObject);
var
  fsj: string;
begin
  inherited;
  ReadCxGrid(FSTKName + '坯布出库录入', Tv1, '坯布出库录入');
  with ADOQueryTemp do
  begin
    Close;
    sql.Clear;
    sql.Add(' select A.* ');
    sql.Add(' from BS_Cloth_IO A');
    sql.Add(' where BCIOID=''' + Trim(FBCId) + '''');
    Open;
  end;
  SCreateCDS(ADOQueryTemp, CDS_Sub);
  SInitCDSData(ADOQueryTemp, CDS_Sub);
  KeyPreview := True;  // 确保表单可以预览按键
//  fsj:='select name=CJName ,Code=null from CheJian';
//  SInitCxGridComboBoxBySql(ADOQueryTemp,v1CheJian,fsj,0,True,'');
end;

procedure TfrmDyeGreyClothOutEdit.TBDelClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty then
    Exit;
  if Trim(CDS_Sub.fieldbyname('BCIOID').AsString) <> '' then
  begin
    if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
      Exit;

    try
      ADOQueryCmd.Connection.BeginTrans;
      with ADOQueryCmd do
      begin
        Close;
        Sql.Clear;
        Sql.Add('exec P_BS_Cloth_Out_Del ');
        Sql.Add(' @BCIOIDS=' + quotedstr(Trim(CDS_Sub.fieldbyname('BCIOID').AsString)));
        Sql.Add(',@DCode=' + quotedstr(Trim(DCode)));
        Sql.Add(',@DName=' + quotedstr(Trim(DName)));
        Open;
      end;
      if ADOQueryCmd.FieldByName('intReturn').AsInteger = -1 then
        raise Exception.Create(pchar(trim(ADOQueryCmd.FieldByName('ShowMsg').AsString)));

      ADOQueryCmd.Connection.CommitTrans;
      CDS_Sub.Delete;
    except
      ADOQueryCmd.Connection.RollbackTrans;
      application.MessageBox(PChar(Exception(ExceptObject).Message), '提示信息', 0);
    end;
  end
  else
    CDS_Sub.Delete;
end;

procedure TfrmDyeGreyClothOutEdit.TBSaveClick(Sender: TObject);
begin
  if CDS_Sub.IsEmpty then
    Exit;
  if CDS_Sub.Locate('IOTime', null, []) = True then
  begin
    Application.MessageBox('出库时间不能为空!', '提示', 0);
    Exit;
  end;
  if CDS_Sub.Locate('IOType', null, []) = True then
  begin
    Application.MessageBox('出库类型不能为空!', '提示', 0);
    Exit;
  end;
 { if CDS_Sub.Locate('CRType;LCKNO', VarArrayOf(['加工出库', Null]), [loPartialKey]) then
  begin
    Application.MessageBox('加工出库的数据流程卡号不能为空!','提示',0);
    Exit;
  end;  }
  if CDS_Sub.Locate('Piece', null, []) = True then
  begin
    Application.MessageBox('匹数不能为空!', '提示', 0);
    Exit;
  end;
  if CDS_Sub.Locate('Qty', null, []) = True then
  begin
    Application.MessageBox('数量不能为空!', '提示', 0);
    Exit;
  end;
  if CDS_Sub.Locate('OrderNo', null, []) = True then
  begin
    Application.MessageBox('计划单号不能为空!', '提示', 0);
    Exit;
  end;
  if SaveCKData() then
  begin
    Application.MessageBox('保存成功!', '提示', 0);
    //ModalResult:=1;
    Exit;
  end;
end;

procedure TfrmDyeGreyClothOutEdit.ToolButton1Click(Sender: TObject);
begin
  WriteCxGrid(fSTKName + '坯布出库录入', Tv1, '坯布出库录入');

end;

procedure TfrmDyeGreyClothOutEdit.Tv1Column2PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin

  try
    frmCompanySel := TfrmCompanySel.Create(Application);
    with frmCompanySel do
    begin
      if Trim(self.CDS_Sub.fieldbyname('IOType').AsString) = '退还' then
        FCoType := '客户'
      else
        FCoType := '供应商';
      if ShowModal = 1 then
      begin
        with Self.CDS_Sub do
        begin
          Edit;
          FieldByName('ToCoNo').Value := Trim(CDS_1.fieldbyname('CoCode').AsString);
          FieldByName('ToCoName').Value := Trim(CDS_1.fieldbyname('CoAbbrName').AsString);
        end;
      end;
    end;
  finally
    frmCompanySel.Free;
  end;

end;

procedure TfrmDyeGreyClothOutEdit.Tv1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
  FFSPID: string;
begin
//  if CDS_Sub.IsEmpty then
//    Exit;
//  if Trim(CDS_Sub.fieldbyname('BCIOID').AsString) <> '' then
//  begin
//    with ADOQueryTemp do
//    begin
//      Close;
//      sql.Clear;
//      sql.Add('select * from BS_Cloth_IO where BCIOID=''' + Trim(CDS_Sub.fieldbyname('BCIOID').AsString) + '''');
//      Open;
//    end;
//    FFSPID := Trim(ADOQueryTemp.fieldbyname('BCIOID').AsString);
//    if Trim(FFSPID) <> '' then
//    begin
//      v1CRType.Options.Editing := False;
//    end
//    else
//    begin
//      v1CRType.Options.Editing := True;
//    end;
//  end
//  else
//  begin
//    v1CRType.Options.Editing := True;
//  end;
end;

procedure TfrmDyeGreyClothOutEdit.v1Column13PropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  with ADOQueryTemp do
  begin
    close;
    sql.Clear;
    sql.Add('exec P_OrderCR');

//    ShowMessage(sql.Text);
    execsql;
  end;

  frmProductOrderListSel := TfrmProductOrderListSel.create(self);
  with frmProductOrderListSel do
  begin
    FWorkshop := self.FWorkshop;
    if ShowModal = 1 then
    begin
      Self.CDS_Sub.FieldByName('OrderNo').Value := Order_Main.fieldbyname('OrderNo').asstring;
//      initGlide();
    end;
    free;
  end;
end;

end.

